part of dartemporal;


/// Returns true if parameter 1 is true and parameter 2 is false.
class TEDiff extends TExpression {
  TExpression _trueMember;   // Holds the TE for true test
  TExpression _falseMember;  // Holds the TE for false test

  TExpression get trueMember => _trueMember;
  TExpression get falseMember => _falseMember;

  /// Class constructor
  TEDiff(TExpression trueTest, TExpression falseTest) {
    _trueMember = trueTest;
    _falseMember = falseTest;
  }

  bool includes(DateTime date) {
    return _trueMember.includes(date) && !(_falseMember.includes(date));
  }

  DateTime first() {
    return _trueMember.first();
  }

  DateTime last() {
    return _trueMember.last();
  }

  /// Allow this class to be "stringified", this does not return the JSON string but does return a Map that can be stringified.
  Map toJson() {
    // Members to JSON list

    return({"TEMasterType": "TEUnion", "ValueTrue": _trueMember.toJson(), "ValueFalse": _falseMember.toJson()});
  }

  /// Create a TEIs object from a Map object that was created manually (why?) or from the toJson method
  ///   is a class factory
  factory TEDiff.fromJson(Map source) {
    List<TExpression> members = [];

    if(source["TEMasterType"] != "TEUnion") {
      throw new InvalidJSONException("Invalid JSON Format: Not TEUnion");
    }

    return new TEDiff(new TExpression.fromJson(source["ValueTrue"]), new TExpression.fromJson(source["ValueFalse"]));
  }
}