part of dartemporal;

/// Represents a logical NOT of the member TE's
class TENot extends TExpression {
  TExpression _child;      // Holds the TE to be "NOT"ed
  DateTime _first;         // The first boundary
  DateTime _last;          // The last boundary

  TExpression get child => _child;

  /// Class constructor for the NOT TE.  Provids a negative of an existing TE
  TENot(TExpression child) {
    _child = child;
    _first = null;
    _last = null;
  }

  /// Is the provided date matched by this TE?
  bool includes(DateTime date) {
    return !_child.includes(date);
  }

  // As this is a UNION, the EARLIEST start date defines the first.
  //   Will return null if there is no EARLIEST date
  DateTime first() {
    return _first;
  }

  // As this is a UNION, the LATEST start date defines the last.
  //   Will return null if there is no LATEST date
  DateTime last() {
    return _last;
  }

  /// Allow this class to be "stringified", this does not return the JSON string but does return a Map that can be stringified.
  Map toJson() {
    return({"TEMasterType": "TENot", "Value": _child.toJson()});
  }

  /// Create a TEIs object from a Map object that was created manually (why?) or from the toJson method
  ///   is a class factory
  factory TENot.fromJson(Map source) {
    TExpression child;

    if(source["TEMasterType"] != "TENot") {
      throw new InvalidJSONException("Invalid JSON Format: Not TENot");
    }

    child = new TExpression.fromJson(source["Value"]);

    return new TENot(child);
  }
}